/*
 * Delay.cpp
 *
 * Student License - for use by students to meet course requirements and
 * perform academic research at degree granting institutions only.  Not
 * for government, commercial, or other organizational use.
 *
 * Code generation for model "Delay".
 *
 * Model version              : 1.6
 * Simulink Coder version : 9.2 (R2019b) 18-Jul-2019
 * C++ source code generated on : Wed Jul 31 22:17:18 2024
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objective: Execution efficiency
 * Validation result: Not run
 */

#include "Delay.h"
#include "Delay_private.h"

/* Model step function */
void DelayModelClass::step()
{
  int_T idxDelay;
  real_T rtb_FilteredSignal;
  int16_T tmp;

  /* Sum: '<S1>/Sum' incorporates:
   *  Gain: '<S1>/FeedbackGain'
   *  Inport: '<Root>/InputAudioIO'
   *  UnitDelay: '<S1>/Unit Delay'
   */
  rtb_FilteredSignal = 0.1174836839918119 * Delay_DW.UnitDelay_DSTATE +
    Delay_U.InputAudio;

  /* Outport: '<Root>/FXOut ' incorporates:
   *  Gain: '<Root>/Gain1'
   *  Gain: '<S1>/Gain2'
   */
  Delay_Y.FXOut = 0.5 * rtb_FilteredSignal * 3.8776941299438481;

  /* Delay: '<S1>/DelayZ' incorporates:
   *  Inport: '<Root>/Feedback '
   */
  if (Delay_U.Feedback <= 0) {
    /* Update for UnitDelay: '<S1>/Unit Delay' */
    Delay_DW.UnitDelay_DSTATE = rtb_FilteredSignal;
  } else {
    if (Delay_U.Feedback > 128) {
      tmp = 128;
    } else {
      tmp = Delay_U.Feedback;
    }

    /* Update for UnitDelay: '<S1>/Unit Delay' */
    Delay_DW.UnitDelay_DSTATE = Delay_DW.DelayZ_DSTATE[static_cast<int16_T>(128
      - tmp)];
  }

  /* End of Delay: '<S1>/DelayZ' */

  /* Update for Delay: '<S1>/DelayZ' */
  for (idxDelay = 0; idxDelay < 127; idxDelay++) {
    Delay_DW.DelayZ_DSTATE[idxDelay] = Delay_DW.DelayZ_DSTATE[idxDelay + 1];
  }

  Delay_DW.DelayZ_DSTATE[127] = rtb_FilteredSignal;

  /* End of Update for Delay: '<S1>/DelayZ' */
}

/* Model initialize function */
void DelayModelClass::initialize()
{
  /* Registration code */

  /* states (dwork) */
  (void) std::memset(static_cast<void *>(&Delay_DW), 0,
                     sizeof(DW_Delay_T));

  /* external inputs */
  (void)std::memset(&Delay_U, 0, sizeof(ExtU_Delay_T));

  /* external outputs */
  Delay_Y.FXOut = 0.0;

  /* InitializeConditions for UnitDelay: '<S1>/Unit Delay' */
  Delay_DW.UnitDelay_DSTATE = 0.0;

  /* InitializeConditions for Delay: '<S1>/DelayZ' */
  std::memset(&Delay_DW.DelayZ_DSTATE[0], 0, sizeof(real_T) << 7U);
}

/* Model terminate function */
void DelayModelClass::terminate()
{
  /* (no terminate code required) */
}

/* Constructor */
DelayModelClass::DelayModelClass() : Delay_M()
{
  /* Currently there is no constructor body generated.*/
}

/* Destructor */
DelayModelClass::~DelayModelClass()
{
  /* Currently there is no destructor body generated.*/
}

/* Real-Time Model get method */
RT_MODEL_Delay_T * DelayModelClass::getRTM()
{
  return (&Delay_M);
}
